function Create(self)

	self.searchRange = RangeRand(0.75, 1.25)*100;

	self.target = nil;
end

function Update(self)

	local newHolder = MovableMan:GetMOFromID(self.RootID);
	if MovableMan:IsActor(newHolder) then
		self.holder = newHolder;
	end
	
	--Detonate.
	if self.fuze then

		part = CreateMOPixel("Warp Flicker", "Techion.rte");
		part.Pos = self.Pos + Vector(self.searchRange, 0):RadRotate(2 * math.pi * math.random());
		part.Vel = Vector(math.random(), 0):RadRotate(2 * math.pi * math.random());
		part.Lifetime = part.Lifetime * RangeRand(0.50, 1.00);
		MovableMan:AddParticle(part);

		part2 = CreateMOPixel("Void Grenade Glow " .. math.random(3), "4V.rte");
		part2.Pos = self.Pos;
		MovableMan:AddParticle(part2);

		if self.fuze:IsPastSimMS(3000) then

			--if math.random() <= 0.20 then

			local dist = Vector(self.searchRange+1,0);
			for actor in MovableMan.Actors do
				--if actor.Team ~= self.Team then
					if actor.ClassName ~= "ADoor" then
						local curdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX);
						if curdist.Magnitude < dist.Magnitude and SceneMan:CastStrengthRay(self.Pos,curdist:SetMagnitude(curdist.Magnitude-actor.Radius),30,Vector(0,0),5,0,SceneMan.SceneWrapsX) == false then
							self.target = actor;
							dist = curdist;
						end
							
					end
				--end
			end

			local effect = CreateMOSRotating("Warp Effect Light", "4V.rte");
			effect.Pos = self.Pos;
			MovableMan:AddParticle(effect);
			effect:GibThis();
			
			if self.target ~= nil then
				
				for i=1, self.target.Radius do
					part = CreateAEmitter("Void Effect " .. math.random(2), "4V.rte");
					part.Pos = self.target.Pos + Vector((RangeRand(0.25, 1)*(self.target.Radius)), 0):RadRotate(2 * math.pi * math.random());
					--part.Vel = Vector(RangeRand(2, 8), 0):RadRotate(2 * math.pi * math.random());
					--part.Lifetime = part.Lifetime * RangeRand(0.50, 1.50)
					MovableMan:AddParticle(part);
				end
--[[
				local effect = CreateMOSRotating("Warp Grenade Effect", "Techion.rte");
				effect.Pos = self.target.Pos;
				MovableMan:AddParticle(effect);
				effect:GibThis();
]]--
				self.target.ToDelete = true;
			end

			self:GibThis();

		end
	elseif self:IsActivated() then
		self.fuze = Timer();
	end
end