--[[
	4zK's Vanilla-Themed Weapons for VW
]]--

if PresetMan:GetModuleID("4V.rte") ~= -1 then

-- Coalition

	i = #CF_ItmNames["Coalition"] + 1
	CF_ItmNames["Coalition"][i] = "Battle Carbine"
	CF_ItmPresets["Coalition"][i] = "Battle Carbine"
	CF_ItmModules["Coalition"][i] = "4V.rte"
	CF_ItmPrices["Coalition"][i] = 90
	CF_ItmDescriptions["Coalition"][i] = "Multi-purpose assault rifle for specialist Coalition units."
	CF_ItmUnlockData["Coalition"][i] = 2500
	CF_ItmTypes["Coalition"][i] = CF_WeaponTypes.RIFLE;
	CF_ItmPowers["Coalition"][i] = 7

-- Techion

	i = #CF_ItmNames["Techion"] + 1
	CF_ItmNames["Techion"][i] = "Nano Swarmer"
	CF_ItmPresets["Techion"][i] = "Nano Swarmer"
	CF_ItmModules["Techion"][i] = "4V.rte"
	CF_ItmPrices["Techion"][i] = 170
	CF_ItmDescriptions["Techion"][i] = "Much like the Nucleo Swarmer, but instead with dosens of nanobots."
	CF_ItmUnlockData["Techion"][i] = 3000
	CF_ItmTypes["Techion"][i] = CF_WeaponTypes.RIFLE;
	CF_ItmPowers["Techion"][i] = 8

	i = #CF_ItmNames["Techion"] + 1
	CF_ItmNames["Techion"][i] = "Void Capsule"
	CF_ItmPresets["Techion"][i] = "Void Capsule"
	CF_ItmModules["Techion"][i] = "4V.rte"
	CF_ItmPrices["Techion"][i] = 100
	CF_ItmDescriptions["Techion"][i] = "This device, upon detonation, warps the closest unit in nearby proximity to a random location in both space and time, potentially removing it from existence, permanently."
	CF_ItmUnlockData["Techion"][i] = 3000
	CF_ItmClasses["Techion"][i] = "TDExplosive"
	CF_ItmTypes["Techion"][i] = CF_WeaponTypes.GRENADE;
	CF_ItmPowers["Techion"][i] = 5

-- Browncoats

	i = #CF_ItmNames["Browncoats"] + 1
	CF_ItmNames["Browncoats"][i] = "DG-500 Blowtorch"
	CF_ItmPresets["Browncoats"][i] = "DG-500 Blowtorch"
	CF_ItmModules["Browncoats"][i] = "4V.rte"
	CF_ItmPrices["Browncoats"][i] = 80
	CF_ItmDescriptions["Browncoats"][i] = "Handheld mini-smeltery, capable of burning through matter, much like a digger."
	CF_ItmUnlockData["Browncoats"][i] = 1200
	CF_ItmTypes["Browncoats"][i] = CF_WeaponTypes.DIGGER;
	CF_ItmPowers["Browncoats"][i] = 7

	i = #CF_ItmNames["Browncoats"] + 1
	CF_ItmNames["Browncoats"][i] = "SG-8 Buckshot"
	CF_ItmPresets["Browncoats"][i] = "SG-8 Buckshot"
	CF_ItmModules["Browncoats"][i] = "4V.rte"
	CF_ItmPrices["Browncoats"][i] = 50
	CF_ItmDescriptions["Browncoats"][i] = "A sturdy, powerful shotgun."
	CF_ItmUnlockData["Browncoats"][i] = 800
	CF_ItmTypes["Browncoats"][i] = CF_WeaponTypes.SHOTGUN;
	CF_ItmPowers["Browncoats"][i] = 5

-- Imperatus

	i = #CF_ItmNames["Imperatus"] + 1
	CF_ItmNames["Imperatus"][i] = "Scrap Grenade"
	CF_ItmPresets["Imperatus"][i] = "Scrap Grenade"
	CF_ItmModules["Imperatus"][i] = "4V.rte"
	CF_ItmPrices["Imperatus"][i] = 5
	CF_ItmDescriptions["Imperatus"][i] = "Bulky throwable explosive made out of scrap metal.  The timer can get wonky and random at times, making the usage of the grenade quite dangerous."
	CF_ItmUnlockData["Imperatus"][i] = 200
	CF_ItmClasses["Imperatus"][i] = "TDExplosive"
	CF_ItmTypes["Imperatus"][i] = CF_WeaponTypes.GRENADE;
	CF_ItmPowers["Imperatus"][i] = 2

	i = #CF_ItmNames["Imperatus"] + 1
	CF_ItmNames["Imperatus"][i] = "Vulcan MG-04"
	CF_ItmPresets["Imperatus"][i] = "Vulcan MG-04"
	CF_ItmModules["Imperatus"][i] = "4V.rte"
	CF_ItmPrices["Imperatus"][i] = 130
	CF_ItmDescriptions["Imperatus"][i] = "Machine gun is capable of shooting explosive rounds at rapid speed."
	CF_ItmUnlockData["Imperatus"][i] = 2500
	CF_ItmTypes["Imperatus"][i] = CF_WeaponTypes.RIFLE;
	CF_ItmPowers["Imperatus"][i] = 8

-- Ronin

	i = #CF_ItmNames["Ronin"] + 1
	CF_ItmNames["Ronin"][i] = "P90"
	CF_ItmPresets["Ronin"][i] = "P90"
	CF_ItmModules["Ronin"][i] = "4V.rte"
	CF_ItmPrices["Ronin"][i] = 40
	CF_ItmDescriptions["Ronin"][i] = "Automatic submachinegun with a 50-round magazine."
	CF_ItmUnlockData["Ronin"][i] = 1200
	CF_ItmTypes["Ronin"][i] = CF_WeaponTypes.PISTOL;--SMG
	CF_ItmPowers["Ronin"][i] = 8

	i = #CF_ItmNames["Ronin"] + 1
	CF_ItmNames["Ronin"][i] = "FAMAS"
	CF_ItmPresets["Ronin"][i] = "FAMAS"
	CF_ItmModules["Ronin"][i] = "4V.rte"
	CF_ItmPrices["Ronin"][i] = 50
	CF_ItmDescriptions["Ronin"][i] = "Light and accurate 3-round-burst bullpup rifle."
	CF_ItmUnlockData["Ronin"][i] = 2000
	CF_ItmTypes["Ronin"][i] = CF_WeaponTypes.RIFLE;
	CF_ItmPowers["Ronin"][i] = 5

	i = #CF_ItmNames["Ronin"] + 1
	CF_ItmNames["Ronin"][i] = "AA-12"
	CF_ItmPresets["Ronin"][i] = "AA-12"
	CF_ItmModules["Ronin"][i] = "4V.rte"
	CF_ItmPrices["Ronin"][i] = 70
	CF_ItmDescriptions["Ronin"][i] = "Fully automatic assault shotgun with a 20-round drum clip."
	CF_ItmUnlockData["Ronin"][i] = 2500
	CF_ItmTypes["Ronin"][i] = CF_WeaponTypes.SHOTGUN;
	CF_ItmPowers["Ronin"][i] = 7

	i = #CF_ItmNames["Ronin"] + 1
	CF_ItmNames["Ronin"][i] = "Steyr AUG"
	CF_ItmPresets["Ronin"][i] = "Steyr AUG"
	CF_ItmModules["Ronin"][i] = "4V.rte"
	CF_ItmPrices["Ronin"][i] = 80
	CF_ItmDescriptions["Ronin"][i] = "Powerful bullpup assault rifle."
	CF_ItmUnlockData["Ronin"][i] = 3000
	CF_ItmTypes["Ronin"][i] = CF_WeaponTypes.RIFLE;
	CF_ItmPowers["Ronin"][i] = 8

	i = #CF_ItmNames["Ronin"] + 1
	CF_ItmNames["Ronin"][i] = "Barrett M107"
	CF_ItmPresets["Ronin"][i] = "Barrett M107"
	CF_ItmModules["Ronin"][i] = "4V.rte"
	CF_ItmPrices["Ronin"][i] = 140
	CF_ItmDescriptions["Ronin"][i] = "Heavy .50 caliber Marksman Rifle."
	CF_ItmUnlockData["Ronin"][i] = 3500
	CF_ItmTypes["Ronin"][i] = CF_WeaponTypes.SNIPER;
	CF_ItmPowers["Ronin"][i] = 9

-- Dummy

	i = #CF_ActNames["Dummy"] + 1
	CF_ActNames["Dummy"][i] = "Dummy Brute"
	CF_ActPresets["Dummy"][i] = "Dummy Brute"
	CF_ActModules["Dummy"][i] = "4V.rte"
	CF_ActPrices["Dummy"][i] = 80
	CF_ActDescriptions["Dummy"][i] = "Armored dummy soldier.  Withstands slightly more fire than a standard dummy, but doesn't match the heavy weight of any ordinary heavy unit."
	CF_ActUnlockData["Dummy"][i] = 2500
	CF_ActTypes["Dummy"][i] = CF_ActorTypes.HEAVY;
	CF_ActPowers["Dummy"][i] = 3

end
